function classr(X,L,q)

%CLASSR(X,L,q)
%Represente une classification dans le plan principal pour les données normalisées et donne le tableau des %classes
%X:donnees  (nxp)
%L:etiquettes des classes (nx1)
%q:nom des individus(nxm) (d?faut:num?ro)


[n,p]=size(X);
k=max(L)
no=num2str([1:n]');
if p>2      
%Analyse en composantes principales
Xn=normtab(X);
[V,D]=eig(corrcoef(X)) 
[Y I]=sort(-diag(D))
V=V(:,I)
Vf=V*sqrt(-Y);
Vc=Xn*V;
X=Vc(:,[1 2]);

end

%Dénomination souhaitée
if nargin<3 
etiq=no;
else
etiq=q;
end

%Repr?sentation dans le plan si k<=6
if k<=7
plot(X((L==1),1),X((L==1),2),'bd')
hold on
plot(X((L==2),1),X((L==2),2),'ro')	  
plot(X((L==3),1),X((L==3),2),'g*')
plot(X((L==4),1),X((L==4),2),'ys')
plot(X((L==5),1),X((L==5),2),'m+')
plot(X((L==6),1),X((L==6),2),'cx')
plot(X((L==7),1),X((L==7),2),'kh')
text(X(:,1),X(:,2),etiq)
hold off
title('Representation des classes dans le plan principal')
grid
end

%Tableau des classes
m=size(etiq,2);
[Y,I]=sort(L);
l=repmat('-',1,18+m);
tit=[blanks(floor(m/2)) 'repartition par classe'  blanks(floor(m/2))];
ind=['|classe|numero |' blanks(floor((m-6)/2)) 'individu' blanks(floor((m-6)/2)) ];            
fprintf(1,'%s \n %s \n %s| \n %s \n',tit,l,ind,l);
for i=1:n
    fprintf(1,'|  %3.0f \t|  %s  \t| %s |\n',Y(i),no(I(i),:),q(I(i),:))
end
fprintf(1,' %s \n',l);

function [Xn]=normtab(X)

%[Xn]=NORMTAB(X)
%Normalisation du tableau de donnees X

Xn=(X-repmat(mean(X),size(X,1),1))*inv(diag(std(X,1)'));
